#define public extern
/*#ifdef __IAR_SYSTEMS_ICC
#include <intrm16c.h>
#include "intm16c.h"
#endif
*/
#include "sfr62.h"
#include "lcd.h"
#undef public
#define public
#include "i2c.h"

void stsp_int (void);
void u2rc_int (void);
#pragma INTERRUPT stsp_int
#pragma INTERRUPT u2rc_int

/**************************************************************************
* Prototypes of Functions
**************************************************************************/
void init_sys(void);
void init_i2c_bus(void);
void read_eeprom_cmd(void);
void write_eeprom_cmd(void);
extern unsigned char func_call(unsigned char a, unsigned char b, unsigned char c,
unsigned char d, unsigned char e);
/**************************************************************************
* Global Variables
**************************************************************************/
unsigned char i2c_ram[256];          // RAM region used in I2C slave transmission
                                     // and reception.
extern unsigned char status;
/***************************************************************************/
void far main(void)
{
 init_sys(); /* Initalize System Clock */
 init_i2c_bus(); /* Initalize i2c Bus */
 asm("fset i");
 while (1)
 {
  write_eeprom_cmd();
  read_eeprom_cmd();
 }
}

/***************************************************************************/
void read_eeprom_cmd(void)
{
 while(check_i2c_bus_status(Set_flag))
 {
  // Check if i2c bus is not busy and set the bus flag.
 }
 i2c_ram[0] = 0x00; // Start address
 if(_iic_mw_start(0x01,&i2c_ram[0],0x50) != 0)
 {                                   // 1st Argument: Designate data
                                     // length sent by master
                                     // 2nd Argument: Designate leading
                                     // address of where data are stored
                                     // 3rd Argument: Designate the
                                     // address of the slave device
                                     // For DEMO we do not provide any error checking.
 }
 while(check_i2c_bus_status(0))
 {
                                     // wait for read to be completed.
 }
// For DEMO we do not provide any error checking.
/* read data */
 while(check_i2c_bus_status(Set_flag))
 {
  // Check if i2c bus is not busy and set the busy flag
 }
 if(_iic_mr_start(0x02,&i2c_ram[0],0x50)!= 0)
 {
  // For DEMO we do not provide any error checking.
 }
 while(check_i2c_bus_status(0))
 {
  // wait for read to be completed.
 }
 // For DEMO we do not provide any error checking.
}

/***************************************************************************/
void write_eeprom_cmd(void)
{
 i2c_ram[0] = 0x00;
 i2c_ram[1] = 0x56;
 i2c_ram[2] = 0x78;
 while(check_i2c_bus_status(Set_flag))
 {
  // repeat until bus is finished
 }
 if(_iic_mw_start(0x03,&i2c_ram[0],0x50)!= 0)// 1st Argument: Designate data
                                     // length sent by master
 {                                   // 2nd Argument: Designate leading
                                     // address of where data are stored
                                     // 3rd Argument: Designate the
                                     // address of the slave device
 }
 while(check_i2c_bus_status(0))
 {
  // wait for read to be completed.
 }
}

/***************************************************************************/
void init_sys(void)
{
 /* System clock initialization */
 prc0 = 1;                           // Aufheben protection
 cm0=cm1=0;                          // auf 16 Mhz einstellen
 prc0 = 0;                           // Sperren protection
}

/***************************************************************************/
void init_i2c_bus(void)              // Initizes I2C slave functions
{
 unsigned char *MEM;
 int i;
 MEM = &i2c_ram[0];
 if( _iic_stop() == 0)
 { /* Check fpr current use. kill bus intialize for start of new message */
  init_i2c_mas_func();
  _iic_ini(0x54, i2c_ram);           // Intialize I2C device driver.
  for(i=0;i<128;i++)
  {
   *MEM++ = 0xff;                    /* zero out ram buffer. */
  }
 }
}

/***************************************************************************/
void far u2rc_int()
{
}

/***************************************************************************/
void far stsp_int()
{
}